app/Http/routes.php
<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It's a breeze. Simply tell Laravel the URIs it should respond to
| and give it the controller to call when that URI is requested.
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::auth();
Route::get('/admin', function () {
    return view('admin.index');
});
route::get('/post/{id}',['as'=>'home.post','uses'=>'AdminPostsController@post']);

Route::get('/home', 'HomeController@index');

Route::group(['middleware' => 'admin'], function () {
    Route::resource('admin/users', 'AdminUsersController');
    Route::resource('admin/posts', 'AdminPostsController');
    Route::resource('admin/categories', 'AdminCategoryController');
    Route::resource('admin/media', 'AdminMediaController');
    Route::resource('admin/comments', 'PostCommentsController');
    Route::resource('admin/comments/replies', 'CommentRpliesController');
    
});
Route::group(['middleware' => 'auth'], function () {
    Route::post('comment/reply', 'CommentRpliesController@createReply');
});

app/Post.php
<?php

namespace App;
// use Cviebrock\EloquentSluggable\SluggableInterface;
// use Cviebrock\EloquentSluggable\SluggableTrait; implements SluggableInterface
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    //
    // use SluggableTrait;

    // protected $sluggable = [
	// 	'build_from'        => 'title',
    //     'save_to'           => 'slug',
    //     'on_update'         => true,
	// ];
    

    protected $fillable =[
        'category_id',
        'user_id',
        'photo_id',
        'title',
        'body'
    ];

    public function user(){
        return $this->belongsTo('App\User');
    }
    public function photo(){
        return $this->belongsTo('App\Photo');
    }
    public function category(){
        return $this->belongsTo('App\Category');
    }
    public function comment(){
        return $this->hasMany('App\Comment');
    }
}

resources/views/admin/posts/create.blade.php
@extends('layouts.admin')
@section('content')


<h1>Create Post</h1>
    <div class="row">
        {!! Form::open(['method'=>'POST','action'=>'AdminPostsController@store','files'=>true ]) !!}
            <div class="form-group">
                {!! Form::label('title','Title:') !!}
                {!! Form::text('title', null ,['class'=>'form-control']) !!}
            </div>

            <div class="form-group">
                {!! Form::label('category_id','category') !!}
                {!! Form::select('category_id',[''=>'Choose Categories'] + $cat , null ,['class'=>'form-control']) !!}
            </div>

            <div class="form-group">
                {!! Form::label('photo_id','Choose image') !!}
                {!! Form::file('photo_id', null) !!}
            </div>

            <div class="form-group">
                {!! Form::label('body','Description') !!}
                {!! Form::textarea('body',null ,['class'=>'form-control','rows'=>5]) !!}
            </div>

            
            <div class="form-group">
                {!! Form::submit('Create post', ['class'=>'btn btn-primary'])!!}
            </div>
        {!! Form::close()!!}
    </div>

    <div class="row alert-danger">
        @include('includes.form_error')
    </div>    
@endsection

resources/views/admin/posts/edit.blade.php
@extends('layouts.admin')
@section('content')
	<h1>Edit Post</h1>
<div class="row">
	<div class="col-sm-3">
		<img height="100" width="250" src="/images/{{$post->photo?$post->photo->file : 'https://via.placeholder.com/150'}}" alt="" class="img-responsive img-rounded">	
	</div>{{-- col img --}}
    <div class="col-sm-9">
        {!! Form::model($post, ['method'=>'PATCH','action'=>['AdminPostsController@update',$post->id],'files'=>true]) !!}
			    <div class='form-group'>
			        {!! Form::label('title','Title:') !!}
			        {!! Form::text('title',null,['class'=>'form-control']) !!}
			    </div>

			    <div class='form-group'>
			        {!! Form::label('category_id','Category:') !!}
			        {!! Form::select('category_id',$cat,null,['class'=>'form-control']) !!}
			    </div>
				
				<div class='form-group'>
			        {!! Form::label('body','Body:') !!}
			        {!! Form::textarea('body',null,['class'=>'form-control', 'rows'=>5]) !!}
			    </div>

			    <div class='form-group'>
			        {!! Form::label('photo_id','Photo:') !!}
			        {!! Form::file('photo_id',null,['class'=>'form-control']) !!}
			    </div>

			    <div class='form-group'>
			        {!! Form::submit('Update Post',['class'=>'btn btn-primary col-sm-6']) !!}
			    </div>

			{!! Form::close() !!}
						
			{!! Form::open(['method'=>'DELETE','action'=>['AdminPostsController@destroy', $post->id] ]) !!}
				<div class="form-group">
					{!! Form::submit('Delete Post', ['class'=>'btn btn-danger col-sm-6'])!!}
				</div>
			{!! Form::close()!!}
	</div>{{-- col edit --}}
</div>{{-- end row --}}
@endsection

resources/views/admin/posts/index.blade.php
@extends('layouts.admin')
@section('content')
    <h1>Posts</h1>
    @if (Session::has('delete_post'))
    <div class="alert-danger">{{session('delete_post')}}</div>
    @endif

    <table class="table">
        <thead>
          <tr>
            <th>Id</th>
            <th>User</th>
            <th>Caregory</th>
            <th>Photo</th>
            <th>Title</th>
            <th>Body</th>
            <th>Post</th>
            <th>Comments</th>
            <th>Created</th>
            <th>Updated</th>
            <th>Edit</th>
          </tr>
        </thead>
        <tbody>
            @if ($posts)
                @foreach ($posts as $post)
                    <tr>
                        <td>{{$post->id}}</td>
                        <td>{{$post->user->name}}</td>
                        <td>{{$post->category?$post->category->name:'uncaregorized'}}</td>
                        <td><img height="50" width="50" src="/images/{{$post->photo?$post->photo->file:'https://via.placeholder.com/400'}}" alt=""></td>
                        <td>{{$post->title}}</td>
                        <td>{{$post->body}}</td>
                        <td><a href="{{route('home.post',$post->id)}}">View post</a></td>
                        <td><a href="{{route('admin.comments.show',$post->id)}}">View comment</a></td>
                        <td>{{$post->created_at->diffForhumans()}}</td>
                        <td>{{$post->updated_at->diffForhumans()}}</td>
                        <td><a href="{{route('admin.posts.edit',$post->id)}}"><i class="fa fa-edit"> Edit</i></a></td>

                    </tr>
                @endforeach
            @endif
        </tbody>
      </table>


@endsection